'                               7SEGMENT ROULETTE WHEEL
'                               (roulette7seg_20m2.bas)

set_up:' ------------- initalise the PICAXE and sound the start-up beep -----------
pause 100
let dirsB = %11111111: pinsB = %00000000
let dirsC = %00000111: pinsC = %00000000
pullup %0111100000000000
tune B.7,4,($27)
setfreq m16
let b1 = 0
'goto start_loop

start_loop:'--------- wait until start button charges the 22uF capacitor ----------
readadc C.7,b0
if b0 < 200  then goto start_loop
'goto wheel_type

wheel_type:'--------- links are used to select the wheel type and speed -----------
pause 2
if pinC.3 = 0 then:b2=65:else:b2=12: endif' (LK4 - select fast/slow speed)
if pinC.6 = 0 then: goto wheel_EURO: endif' (LK1 - European wheel with one zero)
if pinC.5 = 0 then: goto wheel_USA1: endif' (LK2 - American wheel with two zeros)
if pinC.4 = 0 then: goto wheel_USA2: endif' (LK3 - American wheel without zeros)
goto wheel_type

wheel_EURO:
on b1 gosub X0,X32,X15,X19,X4,X21,X2,X25,X17,X34,X6,X27,X13,X36,X11,X30,X8,X23,X10
if b1 = 19 then: b1 = 0: goto wheel_EUROb: endif
gosub run_loop
goto wheel_EURO

wheel_EUROb:
on b1 gosub X5,X24,X16,X33,X1,X20,X14,X31,X9,X22,X18,X29,X7,X28,X12,X35,X3,X26
if b1 = 18 then: b1= 0:goto wheel_EURO: endif
gosub run_loop
goto wheel_EUROb

wheel_USA1:
on b1 gosub X0,X28,X9,X26,X30,X11,X7,X20,X32,X17,X5,X22,X34,X15,X3,X24,X36,X13,X1
if b1 = 19 then: b1 = 0: goto wheel_USA1b: endif
gosub run_loop
goto wheel_USA1

wheel_USA1b:
on b1 gosub X00,X27,X10,X25,X29,X12,X8,X19,X31,X18,X6,X21,X33,X16,X4,X23,X35,X14,X2
if b1 = 19 then: b1= 0:goto wheel_USA1: endif
gosub run_loop
goto wheel_USA1b

wheel_USA2:
on b1 gosub X28,X9,X26,X30,X11,X7,X20,X32,X17,X5,X22,X34,X15,X3,X24,X36,X13,X1
if b1 = 18 then: b1 = 0: goto wheel_USA2b: endif
gosub run_loop
goto wheel_USA2

wheel_USA2b:
on b1 gosub X27,X10,X25,X29,X12,X8,X19,X31,X18,X6,X21,X33,X16,X4,X23,X35,X14,X2
if b1 = 18 then: b1= 0:goto wheel_USA2: endif
gosub run_loop
goto wheel_USA2b

run_loop:'----------- run and click piezo untill 22uF capacitor discharges ---------
readadc C.7,b0
if b0 > 30 then: inc b1: pulsout B.7,200: endif
return

'------------------------ drivers for the 7 segment displays -----------------------
X0:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %00111111: pulsout C.1,1000
let pinsB = %01000000: pulsout C.0,1000
next b3
return
X1:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %00000110: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X2:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01011011: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X3:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01001111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X4:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01100110: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X5:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01101101: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X6:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01111100: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X7:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %00000111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X8:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01111111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X9:
for b3 = 0 to b2
let pinsB = %00000000: pulsout C.2,1000
let pinsB = %01100111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X10:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %00111111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X11:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %00000110: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X12:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01011011: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X13:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01001111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X14:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01100110: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X15:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01101101: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X16:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01111100: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X17:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %00000111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X18:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01111111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X19:
for b3 = 0 to b2
let pinsB = %00000110: pulsout C.2,1000
let pinsB = %01100111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X20:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %00111111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X21:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %00000110: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X22:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01011011: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X23:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01001111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X24:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01100110: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X25:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01101101: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X26:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01111100: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X27:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %00000111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X28:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01111111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X29:
for b3 = 0 to b2
let pinsB = %01011011: pulsout C.2,1000
let pinsB = %01100111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X30:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %00111111: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X31:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %00000110: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X32:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %01011011: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X33:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %01001111: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X34:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %01100110: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X35:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %01101101: pulsout C.1,1000
let pinsB = %00001000: pulsout C.0,1000
next b3
return
X36:
for b3 = 0 to b2
let pinsB = %01001111: pulsout C.2,1000
let pinsB = %01111100: pulsout C.1,1000
let pinsB = %00000001: pulsout C.0,1000
next b3
return
X00:
for b3 = 0 to b2
let pinsB = %00111111: pulsout C.2,1000
let pinsB = %00111111: pulsout C.1,1000
let pinsB = %01000000: pulsout C.0,1000
next b3
return

'--------------------------------- Definition of variables -------------------------
       'b0 = temporary variable
       'b1 = display variable
       'b2 = speed variable
'-----------------------------------------------------------------------------------
